<%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
<%= decidim_form_for(@preview_form, url: participatory_texts_path, class: "form grid-container") do |form| %>
  <button type="button" id="scrollToBottom" onclick="document.getElementById('end-of-page').scrollIntoView({ behavior: 'smooth' });">
    Ir para o Fim da Página
  </button>
  <div class="card">
    <div class="card-divider">
      <h2 class="card-title">
        <%= t(".title") %>
        <%= render partial: "bulk-actions" %>
      </h2>
    </div>

    <div class="card-section">
      <% if @drafts.any? %>
        <p>
          <%= t("info_1", scope: 'decidim.proposals.admin.participatory_texts.index') %>
          <a href="https://www.planalto.gov.br/ccivil_03/_ato2023-2026/2024/decreto/d12002.htm">
            <%=t("decreto", scope: 'decidim.proposals.admin.participatory_texts.index') %>
          </a>
        </p>
        
        <ul id="participatory-text" class="accordion jq-sortable mb-m"
          data-accordion
          data-multi-expand="true"
          data-allow-all-closed="true">
          <%= form.fields_for(:proposals) do |prop_form| %>
          <% proposal= @drafts[prop_form.index] %>
            <li id="proposal-draft-<%= prop_form.index %>" class="accordion-item <%= proposal.try(:article?) ? "is-active" : nil %>" data-accordion-item>
              <a href="#" class="accordion-title flex--sbc">
                <%= preview_participatory_text_section_title(proposal) %>
                <span class="mr-m"><%= icon "menu", class: "icon--small", role: "img", "aria-hidden": true %></span>
              </a>
              <div class="accordion-content" data-tab-content>
                <span class="mr-m">
                  <%= prop_form.check_box :merge, label: t("decidim.admin.participatory_texts.merge"), disabled: proposal.article? ? false : true %>
                  <%= prop_form.check_box :is_interactive, label: t("decidim.admin.participatory_texts.is_interactive") %>
                </span>
                <%= render "article-preview", { form: prop_form, proposal: proposal } %>
              </div>
            </li>
          <% end %>
        </ul>
      <% end -%>

      <%= form.hidden_field :proposal_to_add, id: "proposal-to-add" %>

      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="article">Adicionar Artigo</button>
      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="sub-section">Adicionar Subseção</button>
      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="section">Adicionar Seção</button>
      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="table">Adicionar Tabela</button>
      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="image">Adicionar Imagem</button>
      <button class="add-proposal-draft button tiny button--title" data-proposal-draft-type="comments-section" 
        <%= "disabled" if participatory_text_comments(published_proposals).present? || participatory_text_comments(@drafts).present? %>
      >
        Adicionar Comentários
      </button>
    </div>
  </div>

  <% if @drafts.any? %>
    <div id="end-of-page" class="button--double form-general-submit">
      <%= form.submit t(".save_draft"), name: :save_draft, class: "button" %>
      <%= form.submit t("decidim.admin.participatory_texts.save_document"), class: "button success" %>
      <%= form.submit t(".preview"), name: :show_preview, class: "button muted" %>
      <%= form.hidden_field :preview_url, 
        value: "#{main_component_path(current_component)}?participatory_text_preview=true" 
      %>

      <button id="open-remove-modal" class="button alert">
        Remover parágrafos
      </button>
      <div class="modal-overlay" style="display: none;"></div>
      <div id="remove-modal" style="display: none;">
        <h3 class="remove-modal-title">Remover parágrafos</h3>
        <p class="remove-modal-text">
          Selecione os parágrafos que deseja remover.
        </p>
        <div class="remove-modal-proposal-list">
          <% @drafts.each_with_index do |participatory_text, index| %>
            <div class="remove-modal-checkbox">
              <input 
                id="remove-<%= participatory_text.id %>"
                type="checkbox" 
                class="remove-proposal-check"
                name="delete-checkbox"
                data-proposal-draft-id="<%= index %>"
                title="<%= translated_attribute(participatory_text.title) %>"
              >
              <label for="remove-<%= participatory_text.id %>">
                <%= translated_attribute(participatory_text.title) %>
              </label>
            </div>
          <% end %>
        </div>
        <p class="remove-modal-text">
          <strong>Observação:</strong> Esta ação não pode ser desfeita.
        </p>
        <div class="remove-modal-buttons">
          <button class="remove-close-button button muted" type="button">Cancelar</button>
          <button class="remove-modal-button button alert" type="button">Remover</button>
        </div>
      </div>
      <div id="remove-data-confirm-container" style="display: none;">
        <p class="remove-modal-text">
          <strong>Confirmação:</strong> Confirme que deseja remover os seguintes parágrafos:
        </p>
        <ul id="remove-data-confirm"></ul>
        <div class="remove-modal-buttons">
          <button class="remove-close-button button muted" type="button">Cancelar</button>
          <button id="remove-selected" class="button alert" type="button">Remover</button>
        </div>
      </div>
    </div>
  <% end %>
<% end -%>

<style>
  #scrollToBottom {
    position: fixed;
    right: 20px;
    bottom: 20px;
    padding: 10px 20px;
    background-color: #007BFF;
    color: white;
    border: none;
    border-radius: 5px;
    cursor: pointer;
  }

  #scrollToBottom:hover {
    background-color: #0056b3;
  }

  .remove-modal-proposal-list {
    display: flex;
    flex-direction: column;
    height: 300px;
    overflow-y: scroll;
    gap: 1rem;
  }

  .remove-modal-buttons {
    display: flex;
    justify-content: center;
    gap: 1rem;
  }

  #remove-data-confirm-container {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-color: white;
    padding: 20px;
    border-radius: 5px;
    z-index: 11;
  }

  #remove-data-confirm {
    display: flex;
    flex-direction: column;
    height: 200px;
    overflow-y: scroll;
    gap: 1rem;
  }

  #remove-modal {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-color: white;
    padding: 20px;
    border-radius: 5px;
    z-index: 10;
  }

  .modal-overlay {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    background-color: rgba(0, 0, 0, 0.5); /* Transparência no fundo */
    z-index: 9;
  }
</style>

<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>
<script>
$(window).on("load", function() {
  // Not all browsers submit the buttons as form data.
  $('button[name="save_draft"]').on("click", function(ev) {
    ev.preventDefault();

    var $form = $(this).parents("form");
    $form.append('<input type="hidden" name="save_draft" value="true" />');
    $form.submit();
  });

  $('button[name="show_preview"]').on("click", function(ev) {
    ev.preventDefault();

    var $form = $(this).parents("form");
    $form.append('<input type="hidden" name="show_preview" value="true" />');
    $form.submit();
  });

  $( "#participatory-text" ).on( "sortupdate",
    function( event, ui ) {
      $('#participatory-text li').each(function(idx, li) {
        input= $(li).find("input.position").val(idx+1)
      })
    }
  )

  $(".remove-proposal-check").on("click", function(ev) {
    const proposalDraftId = $(this).data("proposal-draft-id");
    const checkbox = $(`#proposal-draft-${proposalDraftId}-deleted`);
    const removeDataConfirm = document.getElementById("remove-data-confirm");

    // Se o checkbox estiver marcado, define o valor como "1", caso contrário, "false"
    if ($(this).is(":checked")) {
      checkbox.val("1");
      let item = document.createElement('li')
      item.innerHTML = $(this).attr("title");
      item.class = "remove-data-confirm-item";
      item.id = "remove-data-confirm-item-" + proposalDraftId;
      removeDataConfirm.append(item);
    } else {
      checkbox.val("false");
      removeDataConfirm.removeChild(document.getElementById("remove-data-confirm-item-" + proposalDraftId));
    }
  });

  $("#open-remove-modal").on("click", function(ev) {
    ev.preventDefault();
    $(".modal-overlay")[0].style.display = "block";
    $("#remove-modal")[0].style.display = "block";
  });

  $(".remove-close-button").on("click", function(ev) {
    $(".modal-overlay")[0].style.display = "none";
    $("#remove-modal")[0].style.display = "none";
    $("#remove-data-confirm-container")[0].style.display = "none";
    $(".remove-proposal-check:checked").each(function(index, input){
      input.checked = false;
      const proposalDraftId = input.getAttribute("data-proposal-draft-id")
      const checkbox = $(`#proposal-draft-${proposalDraftId}-deleted`);
      const removeDataConfirm = document.getElementById("remove-data-confirm");
      checkbox.val("false");
      removeDataConfirm.removeChild(document.getElementById("remove-data-confirm-item-" + proposalDraftId));
    });
  });

  $(".remove-modal-button").on("click", function(ev) {
    $("#remove-modal")[0].style.display = "none";
    $("#remove-data-confirm-container")[0].style.display = "block";
  });

  $("#remove-selected").on("click", function(ev) {
    let form = $(this).parents("form");
    form.append('<input type="hidden" name="save_draft" value="true" />');
    form.submit();
  })

  $(".add-proposal-draft").on("click", function(ev) {
    ev.preventDefault();

    const buttonPressed = $(ev.target);
    $("#proposal-to-add").val(buttonPressed.data("proposal-draft-type"));

    var form = $(this).parents("form");
    form.append('<input type="hidden" name="save_draft" value="true" />');
    form.submit();
  });

  $(".jq-sortable").sortable();

})
</script>
